package assignment8.random;

import java.util.concurrent.atomic.AtomicLong;

public class AtomicRandomEB implements RandomInterface {
	private static final long a = 25214903917L;
	private static final long c = 11;
	private static final long initial_delay = 1; // ms
	private AtomicLong state;

	public AtomicRandomEB(long seed) {
		state = new AtomicLong(seed);
	}
	
	@Override
	public int nextInt() {
		long max_delay = initial_delay;

		while (true) {
			long orig = state.get();
			// using recurrence equation to generate next seed
			long next = (a * orig + c) & (~0L >>> 16);
			// store the updated seed
			if (state.compareAndSet(orig, next)) {
				return (int) (next >>> 16);
			} else {
				//compute actual delay randomly between 0 and max_delay
				long actual_delay = (long) (Math.random() * max_delay);
				
				//next time we could wait longer! 
				max_delay = max_delay * 2;
				
				try {
					//wait for the computed delay
					Thread.sleep(actual_delay);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}	
}
